/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
define(["require","exports","jquery","TYPO3/CMS/Backend/FormEngineValidation","./Icons","./Modal","TYPO3/CMS/Core/Contrib/imagesloaded.pkgd.min","jquery-ui/draggable","jquery-ui/resizable"],function(t,r,e,i,a,s,o){"use strict";class n{constructor(){this.cropImageContainerSelector="#t3js-crop-image-container",this.cropImageSelector="#t3js-crop-image",this.coverAreaSelector=".t3js-cropper-cover-area",this.cropInfoSelector=".t3js-cropper-info-crop",this.focusAreaSelector="#t3js-cropper-focus-area",this.defaultFocusArea={height:1/3,width:1/3,x:0,y:0},this.defaultOpts={autoCrop:!0,autoCropArea:"0.7",dragMode:"crop",guides:!0,responsive:!0,viewMode:1,zoomable:!1},this.resizeTimeout=450,this.cropBuiltHandler=(()=>{const t=this.cropper.cropper("getImageData"),r=this.currentModal.find(this.cropImageSelector);this.imageOriginalSizeFactor=r.data("originalWidth")/t.naturalWidth,this.cropVariantTriggers.each((r,i)=>{const a=e(i).attr("data-crop-variant-id"),s=this.convertRelativeToAbsoluteCropArea(this.data[a].cropArea,t),o=e.extend(!0,{},this.data[a],{cropArea:s});this.updatePreviewThumbnail(o,e(i))}),this.currentCropVariant.cropArea=this.convertRelativeToAbsoluteCropArea(this.currentCropVariant.cropArea,t),this.cropBox=this.currentModal.find(".cropper-crop-box"),this.setCropArea(this.currentCropVariant.cropArea),this.currentCropVariant.coverAreas&&this.initCoverAreas(this.cropBox,this.currentCropVariant.coverAreas),this.currentCropVariant.focusArea&&(n.isEmptyArea(this.currentCropVariant.focusArea)&&(this.currentCropVariant.focusArea=e.extend(!0,{},this.defaultFocusArea)),this.initFocusArea(this.cropBox),this.scaleAndMoveFocusArea(this.currentCropVariant.focusArea)),this.currentCropVariant.selectedRatio&&(this.setAspectRatio(this.currentCropVariant.allowedAspectRatios[this.currentCropVariant.selectedRatio]),this.setCropArea(this.currentCropVariant.cropArea),this.currentModal.find(`[data-option='${this.currentCropVariant.selectedRatio}']`).addClass("active")),this.cropperCanvas.addClass("is-visible")}),this.cropMoveHandler=(t=>{this.currentCropVariant.cropArea=e.extend(!0,this.currentCropVariant.cropArea,{height:Math.floor(t.height),width:Math.floor(t.width),x:Math.floor(t.x),y:Math.floor(t.y)}),this.updatePreviewThumbnail(this.currentCropVariant,this.activeCropVariantTrigger),this.updateCropVariantData(this.currentCropVariant);const r=Math.round(this.currentCropVariant.cropArea.width*this.imageOriginalSizeFactor),i=Math.round(this.currentCropVariant.cropArea.height*this.imageOriginalSizeFactor);this.cropInfo.text(`${r}×${i} px`)}),this.cropStartHandler=(()=>{this.currentCropVariant.focusArea&&(this.focusArea.draggable("option","disabled",!0),this.focusArea.resizable("option","disabled",!0))}),this.cropEndHandler=(()=>{this.currentCropVariant.focusArea&&(this.focusArea.draggable("option","disabled",!1),this.focusArea.resizable("option","disabled",!1))}),e(window).resize(()=>{this.cropper&&this.cropper.cropper("destroy")}),this.resizeEnd(()=>{this.cropper&&this.init()})}static isEmptyArea(t){return e.isEmptyObject(t)}static wait(t,r){window.setTimeout(t,r)}static toCssPercent(t){return`${100*t}%`}static serializeCropVariants(t){return JSON.stringify(t,(t,r)=>"id"===t||"title"===t||"allowedAspectRatios"===t||"coverAreas"===t?void 0:r)}initializeTrigger(){e(".t3js-image-manipulation-trigger").off("click").click(t=>{t.preventDefault(),this.trigger=e(t.currentTarget),this.show()})}initializeCropperModal(){const t=this.currentModal.find(this.cropImageSelector);o(t,()=>{setTimeout(()=>{this.init()},100)})}show(){const t=this.trigger.data("modalTitle"),r=this.trigger.data("buttonPreviewText"),i=this.trigger.data("buttonDismissText"),o=this.trigger.data("buttonSaveText"),n=this.trigger.data("url"),c=this.trigger.data("payload"),h=this.initializeCropperModal.bind(this);a.getIcon("spinner-circle",a.sizes.default,null,null,a.markupIdentifiers.inline).done(a=>{this.currentModal=s.advanced({additionalCssClasses:["modal-image-manipulation"],buttons:[{btnClass:"btn-default pull-left",dataAttributes:{method:"preview"},icon:"actions-view",text:r},{btnClass:"btn-default",dataAttributes:{method:"dismiss"},icon:"actions-close",text:i},{btnClass:"btn-primary",dataAttributes:{method:"save"},icon:"actions-document-save",text:o}],callback:t=>{e.post({url:n,data:c}).done(r=>{h(),t.find(".t3js-modal-body").append(r).addClass("cropper")})},content:e('<div class="modal-loading">').append(a),size:s.sizes.full,style:s.styles.dark,title:t}),this.currentModal.on("hide.bs.modal",()=>{this.destroy()}),this.currentModal.data("bs.modal").options.backdrop="static"})}init(){const t=this.currentModal.find(this.cropImageSelector),r=e(t).height(),i=e(t).width(),a=this.trigger.attr("data-crop-variants");if(!a)throw new TypeError("ImageManipulation: No cropVariants data found for image");this.data=e.isEmptyObject(this.data)?JSON.parse(a):this.data,this.currentModal.find(this.cropImageContainerSelector).css({height:r,width:i}),this.cropVariantTriggers=this.currentModal.find(".t3js-crop-variant-trigger"),this.activeCropVariantTrigger=this.currentModal.find(".t3js-crop-variant-trigger.is-active"),this.cropInfo=this.currentModal.find(this.cropInfoSelector),this.saveButton=this.currentModal.find("[data-method=save]"),this.previewButton=this.currentModal.find("[data-method=preview]"),this.dismissButton=this.currentModal.find("[data-method=dismiss]"),this.resetButton=this.currentModal.find("[data-method=reset]"),this.cropperCanvas=this.currentModal.find("#js-crop-canvas"),this.aspectRatioTrigger=this.currentModal.find("[data-method=setAspectRatio]"),this.currentCropVariant=this.data[this.activeCropVariantTrigger.attr("data-crop-variant-id")],this.cropVariantTriggers.off("click").on("click",t=>{if(e(t.currentTarget).hasClass("is-active"))return t.stopPropagation(),void t.preventDefault();this.activeCropVariantTrigger.removeClass("is-active"),e(t.currentTarget).addClass("is-active"),this.activeCropVariantTrigger=e(t.currentTarget);const r=this.data[this.activeCropVariantTrigger.attr("data-crop-variant-id")],i=this.cropper.cropper("getImageData");r.cropArea=this.convertRelativeToAbsoluteCropArea(r.cropArea,i),this.currentCropVariant=e.extend(!0,{},r),this.update(r)}),this.aspectRatioTrigger.off("click").on("click",t=>{const r=e(t.currentTarget).attr("data-option"),i=e.extend(!0,{},this.currentCropVariant),a=i.allowedAspectRatios[r];this.setAspectRatio(a),this.setCropArea(i.cropArea),this.currentCropVariant=e.extend(!0,{},i,{selectedRatio:r}),this.update(this.currentCropVariant)}),this.saveButton.off("click").on("click",()=>{this.save(this.data)}),this.trigger.attr("data-preview-url")?this.previewButton.off("click").on("click",()=>{this.openPreview(this.data)}):this.previewButton.hide(),this.dismissButton.off("click").on("click",()=>{this.currentModal.modal("hide")}),this.resetButton.off("click").on("click",t=>{const r=this.cropper.cropper("getImageData"),i=e(t.currentTarget).attr("data-crop-variant");if(t.preventDefault(),t.stopPropagation(),!i)throw new TypeError("TYPO3 Cropper: No cropVariant data attribute found on reset element.");const a=JSON.parse(i),s=this.convertRelativeToAbsoluteCropArea(a.cropArea,r);this.currentCropVariant=e.extend(!0,{},a,{cropArea:s}),this.update(this.currentCropVariant)}),n.isEmptyArea(this.currentCropVariant.cropArea)&&(this.defaultOpts=e.extend({autoCropArea:1},this.defaultOpts)),this.cropper=top.$(t).cropper(e.extend(this.defaultOpts,{built:this.cropBuiltHandler,crop:this.cropMoveHandler,cropend:this.cropEndHandler,cropstart:this.cropStartHandler,data:this.currentCropVariant.cropArea}))}update(t){const r=e.extend(!0,{},t),i=t.allowedAspectRatios[t.selectedRatio];this.currentModal.find("[data-option]").removeClass("active"),this.currentModal.find(`[data-option="${t.selectedRatio}"]`).addClass("active"),this.setAspectRatio(i),this.setCropArea(r.cropArea),this.currentCropVariant=e.extend(!0,{},r,t),this.cropBox.find(this.coverAreaSelector).remove(),this.cropBox.has(this.focusAreaSelector).length&&(this.focusArea.resizable("destroy").draggable("destroy"),this.focusArea.remove()),t.focusArea&&(n.isEmptyArea(t.focusArea)&&(this.currentCropVariant.focusArea=e.extend(!0,{},this.defaultFocusArea)),this.initFocusArea(this.cropBox),this.scaleAndMoveFocusArea(this.currentCropVariant.focusArea)),t.coverAreas&&this.initCoverAreas(this.cropBox,this.currentCropVariant.coverAreas),this.updatePreviewThumbnail(this.currentCropVariant,this.activeCropVariantTrigger)}initFocusArea(t){this.focusArea=e('<div id="t3js-cropper-focus-area" class="cropper-focus-area"></div>'),t.append(this.focusArea),this.focusArea.draggable({containment:t,create:()=>{this.scaleAndMoveFocusArea(this.currentCropVariant.focusArea)},drag:()=>{const{left:r,top:e}=t.offset(),{left:i,top:a}=this.focusArea.offset(),{focusArea:s,coverAreas:o}=this.currentCropVariant;s.x=(i-r)/t.width(),s.y=(a-e)/t.height(),this.updatePreviewThumbnail(this.currentCropVariant,this.activeCropVariantTrigger),this.checkFocusAndCoverAreasCollision(s,o)?this.focusArea.addClass("has-nodrop"):this.focusArea.removeClass("has-nodrop")},revert:()=>{const{left:r,top:e}=t.offset(),{left:i,top:a}=this.focusArea.offset(),{focusArea:s,coverAreas:o}=this.currentCropVariant;return!!this.checkFocusAndCoverAreasCollision(s,o)&&(this.focusArea.removeClass("has-nodrop"),n.wait(()=>{s.x=(i-r)/t.width(),s.y=(a-e)/t.height(),this.updateCropVariantData(this.currentCropVariant)},250),!0)},revertDuration:200,stop:()=>{const{left:r,top:e}=t.offset(),{left:i,top:a}=this.focusArea.offset(),{focusArea:s}=this.currentCropVariant;s.x=(i-r)/t.width(),s.y=(a-e)/t.height(),this.scaleAndMoveFocusArea(s)}}).resizable({containment:t,handles:"all",resize:()=>{const{left:r,top:e}=t.offset(),{left:i,top:a}=this.focusArea.offset(),{focusArea:s,coverAreas:o}=this.currentCropVariant;s.height=this.focusArea.height()/t.height(),s.width=this.focusArea.width()/t.width(),s.x=(i-r)/t.width(),s.y=(a-e)/t.height(),this.updatePreviewThumbnail(this.currentCropVariant,this.activeCropVariantTrigger),this.checkFocusAndCoverAreasCollision(s,o)?this.focusArea.addClass("has-nodrop"):this.focusArea.removeClass("has-nodrop")},stop:(r,i)=>{const{left:a,top:s}=t.offset(),{left:o,top:n}=this.focusArea.offset(),{focusArea:c,coverAreas:h}=this.currentCropVariant;this.checkFocusAndCoverAreasCollision(c,h)?i.element.animate(e.extend(i.originalPosition,i.originalSize),250,()=>{c.height=this.focusArea.height()/t.height(),c.height=this.focusArea.height()/t.height(),c.width=this.focusArea.width()/t.width(),c.x=(o-a)/t.width(),c.y=(n-s)/t.height(),this.scaleAndMoveFocusArea(c),this.focusArea.removeClass("has-nodrop")}):this.scaleAndMoveFocusArea(c)}})}initCoverAreas(t,r){r.forEach(r=>{const i=e('<div class="cropper-cover-area t3js-cropper-cover-area"></div>');t.append(i),i.css({height:n.toCssPercent(r.height),left:n.toCssPercent(r.x),top:n.toCssPercent(r.y),width:n.toCssPercent(r.width)})})}updatePreviewThumbnail(t,r){let e;const i=r.find(".t3js-cropper-preview-thumbnail-crop-area"),a=r.find(".t3js-cropper-preview-thumbnail-crop-image"),s=r.find(".t3js-cropper-preview-thumbnail-focus-area"),o=this.cropper.cropper("getImageData");i.css({height:n.toCssPercent(t.cropArea.height/o.naturalHeight),left:n.toCssPercent(t.cropArea.x/o.naturalWidth),top:n.toCssPercent(t.cropArea.y/o.naturalHeight),width:n.toCssPercent(t.cropArea.width/o.naturalWidth)}),t.focusArea&&s.css({height:n.toCssPercent(t.focusArea.height),left:n.toCssPercent(t.focusArea.x),top:n.toCssPercent(t.focusArea.y),width:n.toCssPercent(t.focusArea.width)}),e=i.css(["width","height","left","top"]),a.css({height:`${parseFloat(e.height)*(1/(t.cropArea.height/o.naturalHeight))}px`,margin:`${-1*parseFloat(e.left)}px`,marginTop:`${-1*parseFloat(e.top)}px`,width:`${parseFloat(e.width)*(1/(t.cropArea.width/o.naturalWidth))}px`})}scaleAndMoveFocusArea(t){this.focusArea.css({height:n.toCssPercent(t.height),left:n.toCssPercent(t.x),top:n.toCssPercent(t.y),width:n.toCssPercent(t.width)}),this.currentCropVariant.focusArea=t,this.updatePreviewThumbnail(this.currentCropVariant,this.activeCropVariantTrigger),this.updateCropVariantData(this.currentCropVariant)}updateCropVariantData(t){const r=this.cropper.cropper("getImageData"),i=this.convertAbsoluteToRelativeCropArea(t.cropArea,r);this.data[t.id]=e.extend(!0,{},t,{cropArea:i})}setAspectRatio(t){this.cropper.cropper("setAspectRatio",t.value)}setCropArea(t){0===this.currentCropVariant.allowedAspectRatios[this.currentCropVariant.selectedRatio].value?this.cropper.cropper("setData",{height:t.height,width:t.width,x:t.x,y:t.y}):this.cropper.cropper("setData",{height:t.height,x:t.x,y:t.y})}checkFocusAndCoverAreasCollision(t,r){return!!r&&r.some(r=>t.x<r.x+r.width&&t.x+t.width>r.x&&t.y<r.y+r.height&&t.height+t.y>r.y)}convertAbsoluteToRelativeCropArea(t,r){const{height:e,width:i,x:a,y:s}=t;return{height:e/r.naturalHeight,width:i/r.naturalWidth,x:a/r.naturalWidth,y:s/r.naturalHeight}}convertRelativeToAbsoluteCropArea(t,r){const{height:e,width:i,x:a,y:s}=t;return{height:e*r.naturalHeight,width:i*r.naturalWidth,x:a*r.naturalWidth,y:s*r.naturalHeight}}setPreviewImages(t){const r=this.cropper,i=r.cropper("getImageData");Object.keys(t).forEach(a=>{const s=t[a],o=this.convertRelativeToAbsoluteCropArea(s.cropArea,i),n=this.trigger.closest(".form-group").find(`.t3js-image-manipulation-preview[data-crop-variant-id="${a}"]`),c=this.trigger.closest(".form-group").find(`.t3js-image-manipulation-selected-ratio[data-crop-variant-id="${a}"]`);if(0===n.length)return;let h=n.width(),p=n.data("preview-height");const d=o.width/o.height,l=h/d;l>p?h=p*d:p=l,h>o.width&&(h=o.width,p=o.height);const u=h/o.width,g=e("<div />").html('<img src="'+r.attr("src")+'">'),f=this.currentModal.find(`.t3-js-ratio-title[data-ratio-id="${s.id}${s.selectedRatio}"]`);c.text(f.text()),g.addClass("cropper-preview-container"),n.empty().append(g),g.wrap('<span class="thumbnail thumbnail-status"></span>'),g.width(h).height(p).find("img").css({height:i.naturalHeight*u,left:-o.x*u,top:-o.y*u,width:i.naturalWidth*u})})}openPreview(t){const r=n.serializeCropVariants(t);let e=this.trigger.attr("data-preview-url");e=e+"&cropVariants="+encodeURIComponent(r),window.open(e,"TYPO3ImageManipulationPreview")}save(t){const r=n.serializeCropVariants(t),a=e(`#${this.trigger.attr("data-field")}`);this.trigger.attr("data-crop-variants",JSON.stringify(t)),this.setPreviewImages(t),a.val(r),i.markFieldAsChanged(a),this.currentModal.modal("hide")}destroy(){this.currentModal&&(void 0!==this.cropper&&null!==this.cropper&&this.cropper.cropper("destroy"),this.cropper=null,this.currentModal=null,this.data=null)}resizeEnd(t){let r;e(window).on("resize",()=>{clearTimeout(r),r=setTimeout(()=>{t()},this.resizeTimeout)})}}return new n});