/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */
define(["require","exports","jquery","./Renderable/InfoBox","./Renderable/Severity","./Renderable/ProgressBar","./Module/PasswordStrength"],function(e,t,s,a,r,n,c){"use strict";return new class{constructor(){this.selectorBody=".t3js-body",this.selectorModuleContent=".t3js-module-content",this.selectorMainContent=".t3js-installer-content",this.selectorProgressBar=".t3js-installer-progress",this.selectorDatabaseConnectOutput=".t3js-installer-databaseConnect-output",this.selectorDatabaseSelectOutput=".t3js-installer-databaseSelect-output",this.selectorDatabaseDataOutput=".t3js-installer-databaseData-output",this.initializeEvents(),s(()=>{this.initialize()})}initializeEvents(){s(document).on("click",".t3js-installer-environmentFolders-retry",e=>{e.preventDefault(),this.showEnvironmentAndFolders()}),s(document).on("click",".t3js-installer-environmentFolders-execute",e=>{e.preventDefault(),this.executeEnvironmentAndFolders()}),s(document).on("click",".t3js-installer-databaseConnect-execute",e=>{e.preventDefault(),this.executeDatabaseConnect()}),s(document).on("click",".t3js-installer-databaseSelect-execute",e=>{e.preventDefault(),this.executeDatabaseSelect()}),s(document).on("click",".t3js-installer-databaseData-execute",e=>{e.preventDefault(),this.executeDatabaseData()}),s(document).on("click",".t3js-installer-defaultConfiguration-execute",e=>{e.preventDefault(),this.executeDefaultConfiguration()}),s(document).on("keyup",".t3-install-form-password-strength",()=>{c.initialize(".t3-install-form-password-strength")}),s(document).on("change","#t3js-connect-database-driver",e=>{let t=s(e.currentTarget).val();s(".t3-install-driver-data").hide(),s(".t3-install-driver-data input").attr("disabled","disabled"),s("#"+t+" input").attr("disabled",null),s("#"+t).show()})}initialize(){this.setProgress(0),this.getMainLayout()}getUrl(e){let t=location.href;return t=t.replace(location.search,""),void 0!==e&&(t=t+"?install[action]="+e),t}setProgress(e){let t=s(this.selectorProgressBar),a=0;0!==e&&(a=e/5*100,t.find(".progress-bar").empty().text(e+" / 5 - "+a+"% Complete")),t.find(".progress-bar").css("width",a+"%").attr("aria-valuenow",a)}getMainLayout(){s.ajax({url:this.getUrl("mainLayout"),cache:!1,success:e=>{s(this.selectorBody).empty().append(e.html),this.checkInstallerAvailable()}})}checkInstallerAvailable(){s.ajax({url:this.getUrl("checkInstallerAvailable"),cache:!1,success:e=>{e.success?this.checkEnvironmentAndFolders():this.showInstallerNotAvailable()}})}showInstallerNotAvailable(){let e=s(this.selectorMainContent);s.ajax({url:this.getUrl("showInstallerNotAvailable"),cache:!1,success:t=>{!0===t.success&&e.empty().append(t.html)}})}checkEnvironmentAndFolders(){this.setProgress(1),s.ajax({url:this.getUrl("checkEnvironmentAndFolders"),cache:!1,success:e=>{!0===e.success?this.checkTrustedHostsPattern():this.showEnvironmentAndFolders()}})}showEnvironmentAndFolders(){let e=s(this.selectorMainContent);s.ajax({url:this.getUrl("showEnvironmentAndFolders"),cache:!1,success:t=>{if(!0===t.success){e.empty().html(t.html);let r=s(".t3js-installer-environment-details"),n=!1;Array.isArray(t.environmentStatusErrors)&&t.environmentStatusErrors.forEach(e=>{n=!0;let t=a.render(e.severity,e.title,e.message);r.append(t)}),Array.isArray(t.environmentStatusWarnings)&&t.environmentStatusWarnings.forEach(e=>{n=!0;let t=a.render(e.severity,e.title,e.message);r.append(t)}),Array.isArray(t.structureErrors)&&t.structureErrors.forEach(e=>{n=!0;let t=a.render(e.severity,e.title,e.message);r.append(t)}),n?(r.show(),s(".t3js-installer-environmentFolders-bad").show()):s(".t3js-installer-environmentFolders-good").show()}}})}executeEnvironmentAndFolders(){s.ajax({url:this.getUrl("executeEnvironmentAndFolders"),cache:!1,success:e=>{!0===e.success&&this.checkTrustedHostsPattern()}})}checkTrustedHostsPattern(){s.ajax({url:this.getUrl("checkTrustedHostsPattern"),cache:!1,success:e=>{!0===e.success?this.executeSilentConfigurationUpdate():this.executeAdjustTrustedHostsPattern()}})}executeAdjustTrustedHostsPattern(){s.ajax({url:this.getUrl("executeAdjustTrustedHostsPattern"),cache:!1,success:()=>{this.executeSilentConfigurationUpdate()}})}executeSilentConfigurationUpdate(){s.ajax({url:this.getUrl("executeSilentConfigurationUpdate"),cache:!1,success:e=>{!0===e.success?this.checkDatabaseConnect():this.executeSilentConfigurationUpdate()}})}checkDatabaseConnect(){this.setProgress(2),s.ajax({url:this.getUrl("checkDatabaseConnect"),cache:!1,success:e=>{!0===e.success?this.checkDatabaseSelect():this.showDatabaseConnect()}})}showDatabaseConnect(){let e=s(this.selectorMainContent);s.ajax({url:this.getUrl("showDatabaseConnect"),cache:!1,success:t=>{!0===t.success&&(e.empty().html(t.html),s("#t3js-connect-database-driver").trigger("change"))}})}executeDatabaseConnect(){let e=s(this.selectorDatabaseConnectOutput),t={"install[action]":"executeDatabaseConnect","install[token]":s(this.selectorModuleContent).data("installer-database-connect-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value}),s.ajax({url:this.getUrl(),cache:!1,method:"POST",data:t,success:t=>{!0===t.success?this.checkDatabaseSelect():Array.isArray(t.status)&&t.status.forEach(t=>{let s=a.render(t.severity,t.title,t.message);e.empty().append(s)})}})}checkDatabaseSelect(){this.setProgress(3),s.ajax({url:this.getUrl("checkDatabaseSelect"),cache:!1,success:e=>{!0===e.success?this.checkDatabaseData():this.showDatabaseSelect()}})}showDatabaseSelect(){let e=s(this.selectorMainContent);s.ajax({url:this.getUrl("showDatabaseSelect"),cache:!1,success:t=>{!0===t.success&&e.empty().html(t.html)}})}executeDatabaseSelect(){let e=s(this.selectorDatabaseSelectOutput),t={"install[action]":"executeDatabaseSelect","install[token]":s(this.selectorModuleContent).data("installer-database-select-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value}),s.ajax({url:this.getUrl(),cache:!1,method:"POST",data:t,success:t=>{!0===t.success?this.checkDatabaseData():Array.isArray(t.status)&&t.status.forEach(t=>{let s=a.render(t.severity,t.title,t.message);e.empty().append(s)})}})}checkDatabaseData(){this.setProgress(4),s.ajax({url:this.getUrl("checkDatabaseData"),cache:!1,success:e=>{!0===e.success?this.showDefaultConfiguration():this.showDatabaseData()}})}showDatabaseData(){let e=s(this.selectorMainContent);s.ajax({url:this.getUrl("showDatabaseData"),cache:!1,success:t=>{!0===t.success&&e.empty().html(t.html)}})}executeDatabaseData(){let e=s(this.selectorDatabaseDataOutput),t={"install[action]":"executeDatabaseData","install[token]":s(this.selectorModuleContent).data("installer-database-data-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((e,s)=>{t[s.name]=s.value});let c=n.render(r.loading,"Loading...","");e.empty().html(c),s.ajax({url:this.getUrl(),cache:!1,method:"POST",data:t,success:t=>{!0===t.success?this.showDefaultConfiguration():Array.isArray(t.status)&&t.status.forEach(t=>{let s=a.render(t.severity,t.title,t.message);e.empty().append(s)})}})}showDefaultConfiguration(){let e=s(this.selectorMainContent);this.setProgress(5),s.ajax({url:this.getUrl("showDefaultConfiguration"),cache:!1,success:t=>{!0===t.success&&e.empty().html(t.html)}})}executeDefaultConfiguration(){let e={"install[action]":"executeDefaultConfiguration","install[token]":s(this.selectorModuleContent).data("installer-default-configuration-execute-token")};s(s(this.selectorBody+" form").serializeArray()).each((t,s)=>{e[s.name]=s.value}),s.ajax({url:this.getUrl(),cache:!1,method:"POST",data:e,success:e=>{top.location.href=e.redirect}})}}});